    let kmMotor=new KMMotorOneWebBLE();
    let actionPlaySpeedRPM=4;//4rpm
    let actionMidSpeedRPM=30;//4rpm
    let actionHiSpeedRPM=60;
    let mortorRot=new KMRotState();
    /**
     * 数値にキャストする関数
     * 数値以外は0を返す
     * Infinityも0とする
     */
    function UTL_N(val){
        let r=parseFloat(val,10);
        return(isNaN(r)||!isFinite(r)?0:r);
    }


    //------------------------------------//
    //section::モーター接続制御
    //------------------------------------//

    kmMotor.on(kmMotor.EVENT_TYPE.connect,(kMDeviceInfo)=>{
        console.log("onConnect:"+kMDeviceInfo.isConnect);
        motorConInit();
        motorConnectStateChange(true);
    });
    kmMotor.on(kmMotor.EVENT_TYPE.disconnect,(kMDeviceInfo)=>{
        console.log("disconnect:"+kMDeviceInfo.isConnect);
        motorConnectStateChange(false);
    });


    function motorConnectStateChange(flg){
        $('#motorConnectbtn').toggleClass('discon',flg);
        $('#cltBtns').toggleClass('noConnect',!flg);
    }

    //接続時モーター初期設定
    function motorConInit(){
        if(kmMotor.deviceInfo.isConnect){
            kmMotor.cmdEnable();
            kmMotor.cmdSpeed_rpm(actionPlaySpeedRPM);//4rpm
        }
        kmMotor.removeAllListeners(kmMotor.EVENT_TYPE.motorMeasurement);
        kmMotor.on(kmMotor.EVENT_TYPE.motorMeasurement,function(kMRotState){
            mortorRot=kMRotState;
            //console.log(kMRotState);//info::debug
        });
    }


    //------------------------------------//
    //section::モーターアクション
    //------------------------------------//

    //モーター移動 無限
    function actionRun(speedRPM,isReverse) {
        if(!kmMotor.deviceInfo.isConnect){return;}
        //kmMotor.cmdEnable();
        kmMotor.cmdSpeed_rpm(speedRPM);
        if(isReverse){
            kmMotor.cmdRunReverse();
        }else{
            kmMotor.cmdRunForward();
        }
    }

    /**
     * 角度
     * @param speedRPM
     * @param deg
     * @param isTopRel false:現在位置から true:12時からの相対
     */
    function actionDeg(speedRPM,deg,isTopRel){
        if(!kmMotor.deviceInfo.isConnect){return;}
        //kmMotor.cmdEnable();
        //kmMotor.cmdSpeed_rpm(actionHiSpeedRPM);
        let position=mortorRot.position;
        let  tarPos=position+KMUtl.degreeToRadian(1)-(isTopRel?(position%(Math.PI*2)):0)+KMUtl.degreeToRadian(deg);
        console.log("position:",position,"tarPos:",tarPos,"(position%(Math.PI*2)):",(position%(Math.PI*2)));
        kmMotor.cmdMoveToPosition(tarPos,KMUtl.rpmToRadianSec(speedRPM));
    }

    //停止
    function actionPause() {
        kmMotor.cmdStop();
    }

    //ティーチング再生
    // function actionPlayback(idx) {
    //     if(!kmMotor.deviceInfo.isConnect){return;}
    //     let sidx=UTL_N(idx);
    //     kmMotor.cmdStartPlaybackMotion(sidx,1,1);
    // }

    //------------------------------------//
    //section::音声認識
    //------------------------------------//
    let recognizing = false;
    let recognition = new webkitSpeechRecognition();
    let final_transcript="";
    let ignore_onend = false;
    recognition.lang="ja-JP";
    recognition.continuous = true;
    recognition.interimResults = false;//暫定的な値を返すか


    recognition.onstart = function () {
        recognizing = true;
        ignore_onend = true;
        $('#micConnectbtn').toggleClass('on',true);
    };

    recognition.onerror = function (event) {

        console.log(event.error);
        putLog(event.error);
    };

    recognition.onend = function () {
        if(ignore_onend){
            recognition.start();
        }else{
            recognizing = false;
            $('#micConnectbtn').toggleClass('on',false);
        }
    };

    recognition.onresult = function (event) {
        let interim_transcript = '';
        for (let i = event.resultIndex; i < event.results.length; ++i) {
            if (event.results[i].isFinal) {
                final_transcript += event.results[i][0].transcript;
            } else {
               // interim_transcript += event.results[i][0].transcript;
            }
        }
        if(final_transcript){
            console.log("＞＞",final_transcript);
            putLog(final_transcript);
            keywordAnalysis(final_transcript);
            final_transcript="";
        }
    };

    function recStop(){
        if (recognition) {
            ignore_onend=false;
            recognition.stop();
        }
    }
    function recStart(){
        if (recognition) {
            recognition.start();
            ignore_onend = true;
        }
    }
    //音声入力を停止し、一定時間後に再度音声入力を復帰する
    let reRecIntervalID=0;
    function reRecInterval(sec){
        recStop();
        clearTimeout(reRecIntervalID);
        reRecIntervalID=setTimeout(()=>{
            recStart();
        },sec*1000);
    }
    //------------------------------------//
    //section::キーワード解析
    //------------------------------------//
    function keywordAnalysis(str){
        if(typeof str !=="string"){return;}
        if(str.indexOf("時")!==-1){
            if(!isNaN(parseInt(str))){
                actionDeg(actionMidSpeedRPM,UTL_N(str)*30,true);
            }
        }else if(str.indexOf("回転")!==-1){
            let spst=str;
            let isRev=(spst.indexOf("逆")!==-1);
            let speedRPM=(spst.indexOf("大")!==-1)?actionHiSpeedRPM:actionMidSpeedRPM;
            let isDeg=(spst.indexOf("°")!==-1||spst.indexOf("度")!==-1);//度
            spst=spst.replace(/回転/g,"");
            spst=spst.replace(/逆/g,"");
            spst=spst.replace(/大/g,"");
            spst=spst.replace(/°/g,"");
            spst=spst.replace(/度/g,"");
            spst=spst.replace(/に/g,"");
            if(UTL_N(spst)){
                let toDeg=isDeg?UTL_N(spst):UTL_N(spst)*360;
                toDeg=isRev?-toDeg:toDeg;
                actionDeg(speedRPM,toDeg,false);
            }else{
                actionRun(speedRPM,isRev);
            }
        }
        else if(str.indexOf("ストップ")!==-1||str.indexOf("停止")!==-1){
            actionPause();

        }
    }
    //------------------------------------//
    //entry
    //------------------------------------//
    $(function() {
        //ボタンイベント
        $('#motorConnectbtn').on('click', () =>{
            if(kmMotor.isConnect){
                kmMotor.disConnect();
            }else{
                kmMotor.connect();
            }
        });
        $('#micConnectbtn').on('click', () =>{
            if (recognizing) {
                recStop();
            }else{
                recStart();
            }
        });
        $('#actionStopbtn').on('click', () =>{
            if(kmMotor.isConnect){
                kmMotor.cmdDisable();
                kmMotor.disConnect();
                recStop();
            }
        });


    });

    function putLog(str){
        let log=$("#log").text();
        let lis=log.split("\n");
        lis.unshift(str);
        if(lis.length>5){
            lis.pop();
        }
        $("#log").text(lis.join("\n"));
    }

